/* Copyright 2008 Daniel Vokó <vokoda@gmail.com>
 * 
 * This file is part of Sagittarius.
 *
 * Sagittarius is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sagittarius is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Sagittarius.  If not, see <http://www.gnu.org/licenses/>.
 */

using System;

namespace Sagittarius.Metadata
{
	public class ExifSection :MetadataSection
	{
		public ExifSection():base()
		{
			//Console.WriteLine("Entering ExifSection constructor");
			this.SectionName=Strs.XMP_EXIF_SECT_NAME;
			base.AddElement(new MetadataElement("Marked",""));
			base.AddElement(new MetadataElement("Exif Image Width",""));
			base.AddElement(new MetadataElement("Exif Image Length",""));
			base.AddElement(new MetadataElement("Bits Per Sample",""));
			base.AddElement(new MetadataElement("Compression",""));
			base.AddElement(new MetadataElement("Photometric Interpretation",""));
			base.AddElement(new MetadataElement("Orientation",""));
			base.AddElement(new MetadataElement("Samples Per Pixel",""));
			base.AddElement(new MetadataElement("Planar Configuration",""));
			base.AddElement(new MetadataElement("Y Cb Cr Sub Sampling",""));
			base.AddElement(new MetadataElement("Y Cb Cr Positioning",""));
			base.AddElement(new MetadataElement("Y Cb Cr Coefficients",""));
			base.AddElement(new MetadataElement("X Resolution",""));
			base.AddElement(new MetadataElement("Y Resolution",""));
			base.AddElement(new MetadataElement("Resolution Unit",""));
			base.AddElement(new MetadataElement("Transfer Function",""));
			base.AddElement(new MetadataElement("White Point",""));
			base.AddElement(new MetadataElement("Primary Chromaticities",""));
			base.AddElement(new MetadataElement("Reference Black White",""));
			base.AddElement(new MetadataElement("Date/Time Original",""));
			base.AddElement(new MetadataElement("Image Description",""));
			base.AddElement(new MetadataElement("Make",""));
			base.AddElement(new MetadataElement("Camera Model Name",""));
			base.AddElement(new MetadataElement("Software","")); 
			base.AddElement(new MetadataElement("Exif Version",""));
			base.AddElement(new MetadataElement("Flashpix Version",""));
			base.AddElement(new MetadataElement("Color Space",""));
			base.AddElement(new MetadataElement("Components Configuration",""));
			base.AddElement(new MetadataElement("Compressed Bits Per Pixel",""));
			base.AddElement(new MetadataElement("Pixel X Dimension",""));
			base.AddElement(new MetadataElement("Pixel Y Dimension",""));
			base.AddElement(new MetadataElement("User Comment",""));
			base.AddElement(new MetadataElement("Related Sound File",""));
			base.AddElement(new MetadataElement("Date/Time Digitized",""));
			base.AddElement(new MetadataElement("Exposure Time",""));
			base.AddElement(new MetadataElement("F Number",""));
			base.AddElement(new MetadataElement("Exposure Program",""));
			base.AddElement(new MetadataElement("Spectral Sensitivity",""));
			base.AddElement(new MetadataElement("ISO",""));
			base.AddElement(new MetadataElement("Shutter Speed Value",""));
			base.AddElement(new MetadataElement("Aperture Value",""));
			base.AddElement(new MetadataElement("Brightness Value",""));
			base.AddElement(new MetadataElement("Exposure Compensation",""));
			base.AddElement(new MetadataElement("Max Aperture Value",""));
			base.AddElement(new MetadataElement("Subject Distance",""));
			base.AddElement(new MetadataElement("Metering Mode",""));
			base.AddElement(new MetadataElement("Light Source",""));
			base.AddElement(new MetadataElement("Flash",""));
			base.AddElement(new MetadataElement("Focal Length",""));
			base.AddElement(new MetadataElement("Subject Area",""));
			base.AddElement(new MetadataElement("Flash Energy",""));
			base.AddElement(new MetadataElement("Spatial Frequency Response",""));
			base.AddElement(new MetadataElement("Focal Plane X Resolution",""));
			base.AddElement(new MetadataElement("FocalPlane Y Resolution",""));
			base.AddElement(new MetadataElement("Focal Plane Resolution Unit",""));
			base.AddElement(new MetadataElement("Subject Location",""));
			base.AddElement(new MetadataElement("Exposure Index",""));
			base.AddElement(new MetadataElement("Sensing Method",""));
			base.AddElement(new MetadataElement("File Source",""));
			base.AddElement(new MetadataElement("Scene Capture",""));
			base.AddElement(new MetadataElement("CFA Pattern",""));
			base.AddElement(new MetadataElement("Custom Rendered",""));
			base.AddElement(new MetadataElement("Exposure Mode",""));
			base.AddElement(new MetadataElement("White Balance",""));
			base.AddElement(new MetadataElement("Digital Zoom Ratio",""));
			base.AddElement(new MetadataElement("Focal Length In 35 mm Format",""));
			base.AddElement(new MetadataElement("Scene Capture Type",""));
			base.AddElement(new MetadataElement("Gain Control",""));
			base.AddElement(new MetadataElement("Contrast",""));
			base.AddElement(new MetadataElement("Saturation",""));
			base.AddElement(new MetadataElement("Sharpness",""));
			base.AddElement(new MetadataElement("Device Setting Description",""));
			base.AddElement(new MetadataElement("Subject Distance Range",""));
			base.AddElement(new MetadataElement("Image Unique ID",""));
			base.AddElement(new MetadataElement("GPS Version ID",""));
			base.AddElement(new MetadataElement("GPS Latitude",""));
			base.AddElement(new MetadataElement("GPS Longitude",""));
			base.AddElement(new MetadataElement("GPS Altitude Ref",""));
			base.AddElement(new MetadataElement("GPS Altitude",""));
			base.AddElement(new MetadataElement("GPS Satellites",""));
			base.AddElement(new MetadataElement("GPS Status",""));
			base.AddElement(new MetadataElement("GPS Measure Mode",""));
			base.AddElement(new MetadataElement("GPS DOP",""));
			base.AddElement(new MetadataElement("GPS Speed Ref",""));
			base.AddElement(new MetadataElement("GPS Speed",""));
			base.AddElement(new MetadataElement("GPS Track Ref",""));
			base.AddElement(new MetadataElement("GPS Track",""));
			base.AddElement(new MetadataElement("GPS Img Direction Ref",""));
			base.AddElement(new MetadataElement("GPS Img Direction",""));
			base.AddElement(new MetadataElement("GPS Map Datum",""));
			base.AddElement(new MetadataElement("GPS Dest Latitude",""));
			base.AddElement(new MetadataElement("GPS Dest Longitude",""));
			base.AddElement(new MetadataElement("GPS Dest Bearing Ref",""));
			base.AddElement(new MetadataElement("GPS Dest Bearing",""));
			base.AddElement(new MetadataElement("GPS Dest Distance Ref",""));
			base.AddElement(new MetadataElement("GPS Dest Distance",""));
			base.AddElement(new MetadataElement("GPS Area Information",""));
			base.AddElement(new MetadataElement("GPS Differential",""));
			base.AddElement(new MetadataElement("Lens",""));
			base.AddElement(new MetadataElement("Serial Number",""));
			//Console.WriteLine("Leaving ExifSection constructor");
		}
		
		public override void AddElement(MetadataElement element)
		{
			throw new Exception("ExifSection cannot have other elements than the predefined ones"); 
		}
		
		public override void SetElement (string key, string newValue)
		{
			//Console.WriteLine("SetElement");
			base.SetElement(key, newValue);
		}
		
		public new ExifSection Copy()
		{
			//Console.WriteLine("Entering IptcSection.copy");
			ExifSection result = new ExifSection();
			foreach (MetadataElement element in elementsList)
			{
				result.SetElement(element.Key,element.Value);
			}
			//Console.WriteLine("Leaving IptcSection.copy");
			return result;
		}
	}
}
