/* Copyright 2008 Daniel Vokó <vokoda@gmail.com>
 * 
 * This file is part of Sagittarius.
 *
 * Sagittarius is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * Sagittarius is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Sagittarius.  If not, see <http://www.gnu.org/licenses/>.
 */

using System;
using Sagittarius.Widgets;
using System.Collections.Generic;

namespace Sagittarius
{
	
	
	public partial class RenameDialog : Gtk.Dialog
	{
		private List<NamePiece> pieces;
		
		public RenameDialog()
		{
			this.Build();
			pieces = new List<NamePiece>();
			AddPiece();
		}

		public void AddPiece()
		{
			NamePiece piece = new NamePiece();
			pieces.Add(piece);
			vBox.PackStart(piece,true,false,0);
		}
		
		public void RemovePiece()
		{
			Console.WriteLine("Entering Sagittarius.RenameDialog.RemovePiece");
			Console.WriteLine(pieces.Count);
			vBox.Remove(pieces[pieces.Count-1]);
			pieces.RemoveAt(pieces.Count-1);
			Console.WriteLine("Leaving Sagittarius.RenameDialog.RemovePiece");
		}
		
		protected virtual void OnButtonCancelClicked (object sender, System.EventArgs e)
		{
			this.Hide();
			this.Destroy();
		}

		protected virtual void OnButtonOkClicked (object sender, System.EventArgs e)
		{
			this.Hide();
			this.Destroy();
		}

		protected virtual void OnAddBtnClicked (object sender, System.EventArgs e)
		{
			AddPiece();
		}

		protected virtual void OnRemBtnClicked (object sender, System.EventArgs e)
		{
			RemovePiece();
		}
	}
}
